package org.netkernel.mod.architecture;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class EntityViewAccessor extends StandardAccessorImpl
{
	public static String formatViewPath(String aId)
	{	return "javascript:loadTab('/tools/ae/view/"+aId+"')";
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String viewId=aContext.getThisRequest().getArgumentValue("viewId");
		String entityId=aContext.getThisRequest().getArgumentValue("entityId");
		ISERep config = aContext.source("active:seConfig",ISERep.class);
		INKFResponseReadOnly respIn=config.generateView(viewId,entityId,aContext);
		INKFResponse resp=aContext.createResponseFrom(respIn);
		
		//setup up wrapping parameters from space explorer config with passed
		//parameters taking precedence
		if (respIn.hasHeader("WrappedControlPanel"))
		{
			IHDSNode source=config.getSource(viewId);
			
			IHDSNode headingHeader=null;
			if (respIn.hasHeader("WrappedControlHeading"))
			{	headingHeader=(IHDSNode)respIn.getHeader("WrappedControlHeading");
			}
			
			HDSBuilder b=new HDSBuilder();
			b.pushNode("view");
			
			if (respIn.hasHeader("WrappedControlPanelIcon"))
			{	b.addNode("icon", respIn.getHeader("WrappedControlPanelIcon"));
			}
			else if (headingHeader!=null)
			{	for (IHDSNode iconNode : headingHeader.getNodes("/*/icon"))
				{	b.importNode(iconNode);
				}
			}
			else
			{	for( IHDSNode iconNode : source.getNodes("icon"))
				{	b.importNode(iconNode);
				}
			}
			
			if (respIn.hasHeader("WrappedControlPanel") && respIn.getHeader("WrappedControlPanel") instanceof String)
			{	b.addNode("title", respIn.getHeader("WrappedControlPanel"));
			}
			else if (headingHeader!=null)
			{	b.addNode("title", headingHeader.getFirstValue("/*/title"));
			}
			else
			{	b.addNode("title", source.getFirstValue("name"));
			}
			
			if (respIn.hasHeader("WrappedControlPanelSubtitle"))
			{	b.addNode("subtitle", respIn.getHeader("WrappedControlPanelSubtitle"));
			}
			else if (headingHeader!=null)
			{	b.addNode("subtitle", headingHeader.getFirstValue("/*/subtitle"));
			}
			else
			{	b.addNode("subtitle", source.getFirstValue("desc"));
			}
			resp.setHeader("WrappedControlHeading", b.getRoot());
		}

	}
}
