package org.netkernel.mod.architecture;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.nkf.INKFLocale;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.urii.SimpleIdentifierImpl;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.request.IRequestScopeLevel;
import org.netkernel.request.impl.RequestScopeLevelImpl;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.ISpace;
import org.netkernel.urii.impl.Version;

public class SEConfigAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		INKFRequest req=aContext.createRequest("active:spaceAggregateHDS");
		req.addArgument("uri", "res:/etc/system/SpaceExplorerConfig.xml");
		req.setRepresentationClass(IHDSNode.class);
		IHDSNode importedSpaces=(IHDSNode)aContext.issueRequest(req);
		
		//IHDSNode importedSpaces=aContext.source("active:SimpleImportDiscovery",IHDSNode.class);
		IKernel k=aContext.getKernelContext().getKernel();
		SEConfig config = new SEConfig();

		for (IHDSNode spaceNode: importedSpaces.getNodes("/spaces/space"))
		{
			IIdentifier uri=new SimpleIdentifierImpl(spaceNode.getFirstValue("id").toString());
			Version version=new Version(spaceNode.getFirstValue("version").toString());
			ISpace space=k.getSpace(uri, version, version);
			
			for (IHDSNode configNode: spaceNode.getNodes("*/view"))
			{	config.addConfig(configNode,space);			
			}
			
		}
		config.close();
		aContext.createResponseFrom(config);
		
	}
}
