package org.netkernel.mod.architecture.bits;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.boot.BootUtils;
import org.netkernel.layer0.meta.IModuleMeta;
import org.netkernel.layer0.nkf.*;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.xda.IXDA;

public class Settings extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String settingsIdentifier="fpds:/etc/system/explorerSettings.xml";
			
		IHDSNode params=aContext.source("httpRequest:/params",IHDSNode.class);
		
		
		if (params.getFirstNode("delete")!=null)
		{	aContext.delete(settingsIdentifier);
		}
		
		//update library settings
		String library=(String)params.getFirstValue("library");
		if (library!=null)
		{	String entity=(String)params.getFirstValue("entity");
			IRepDeployedModules modules=(IRepDeployedModules)aContext.source("active:moduleList",IRepDeployedModules.class);
			String moduleIdentifier=((IModuleMeta)modules.metadataForHash(entity)).getIdentifier();
			String xpath="/explorer/libraries/library[text()='"+moduleIdentifier+"']";
			IXDA settings=aContext.source(settingsIdentifier,IXDA.class).getClone();
			if (library.equals("false"))
			{	settings.delete(xpath);
			}
			else
			{	if (!settings.isTrue(xpath))
				{	settings.appendPath("/explorer/libraries/", "library", moduleIdentifier);
				}
			}
			aContext.sink(settingsIdentifier, settings);
			aContext.createResponseFrom("set");
		}
		
		INKFRequest req=aContext.createRequest("active:xslt");
		req.addArgument("operator","res:/org/netkernel/mod/architecture/bits/styleSettings.xsl");
		req.addArgument("settings", settingsIdentifier);
		req.addArgument("operand", "active:moduleListDoc");
		INKFResponseReadOnly respIn=aContext.issueRequestForResponse(req);
		
		INKFResponse resp=aContext.createResponseFrom(respIn);
		resp.setHeader("WrappedControlPanel", "Settings");
		resp.setHeader("WrappedControlPanelSubtitle", "Configure space explorer settings");
		resp.setHeader("WrappedControlPanelIcon", "/tools/ae/pub/images/48/Settings48.png");
		
	}
}
