package org.netkernel.mod.architecture.bits;

import java.util.*;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.boot.IModule;
import org.netkernel.layer0.meta.ISpaceElements;
import org.netkernel.layer0.meta.ISpaceMeta;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.layer0.representation.impl.HDSFactory;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.module.standard.endpoint.StandardTransportImpl;
import org.netkernel.mod.architecture.Utils;
import org.netkernel.urii.IEndpoint;
import org.netkernel.urii.IMetaRepresentation;
import org.netkernel.urii.ISpace;
import org.netkernel.urii.ISpaceWithIdentity;
import org.w3c.dom.Document;

public class SpaceRootedPhysicalStructure extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String entityHash=aContext.getThisRequest().getArgumentValue("entityId");
		
		IRepDeployedModules modules=aContext.source("active:moduleList",IRepDeployedModules.class);
		IMetaRepresentation meta=modules.metadataForHash(entityHash);
		
		HDSBuilder b=new HDSBuilder();
		b.addNode("title",meta.getName());
		b.addNode("depth","all");
		b.addNode("root",entityHash);
		
		INKFRequest req=aContext.createRequest("active:StaticStructureDiagramView");
		req.addArgumentByValue("defaults", b.getRoot());
		INKFResponseReadOnly respIn=aContext.issueRequestForResponse(req);
		aContext.createResponseFrom(respIn);
	}
}
