package org.netkernel.mod.architecture.bits.channel;

import java.util.ArrayList;
import java.util.List;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.urii.IMetaRepresentation;

public class ChannelDefinition
{
	private String mPath;
	private List<String> mPathList;
	private List<String> mEndpoints=new ArrayList<String>();
	private int mHeight;
	
	public ChannelDefinition(String aPath, List<String> aPathList)
	{	mPath=aPath;
		mPathList=aPathList;
	}
	
	public void addOrphanParent(String aParentSpace)
	{	mPath=aParentSpace+":"+mPath;
		mPathList.add(0, aParentSpace);
	}
	
	
	public void addLogicalEndpoint(String aLogicalEndpoint)
	{	mEndpoints.add(aLogicalEndpoint);
	}
	
	public List<String> getEndpoints()
	{	return mEndpoints;
	}
	
	public String getPath()
	{	return mPath;
	}
	
	public List<String> getPathList()
	{	return mPathList;
	}
	
	public void setHeight(int aHeight)
	{	mHeight=aHeight;
	}
	
	public int getHeight()
	{	return mHeight;
	}
	
	public String getTitle(IRepDeployedModules aModules)
	{
		StringBuilder sb=new StringBuilder(128);
		boolean first=true;
		String firstSpaceHash=mPathList.get(0);
		String lastSpaceHash=mPathList.get(mPathList.size()-1);
		//only for physical endpoints
		//int i=spaceHash.lastIndexOf('/');
		//spaceHash=spaceHash.substring(0, i);
		for (String endpointHash: mEndpoints)
		{
			IMetaRepresentation meta=aModules.metadataForHash(firstSpaceHash+"/"+endpointHash);
			if (meta!=null)
			{
				if (!first)
				{	sb.append(", ");
				}
				first=false;
				sb.append(meta.getName());
			}
			else
			{	meta=aModules.metadataForHash(lastSpaceHash+"/"+endpointHash);
				if (meta!=null)
				{
					if (!first)
					{	sb.append(", ");
					}
					first=false;
					sb.append(meta.getName());
				}
			}	
		}
		return sb.toString();
	}
}
