package org.netkernel.mod.architecture.bits.channel;

import java.util.*;

import org.netkernel.ext.system.representation.IRepDeployedModules;

public class LogicalEndpointDefinition
{
	private String mLogicalEndpoint;
	private Map<String,String> mSpaces=new HashMap<String,String>();
	//private Map<String,String> mPhysicalForSpace=new HashMap<String,String>();
	private String mOrigin;
	private Set<String> mNotHeads=new HashSet<String>();
	
	public LogicalEndpointDefinition(String aLogicalEndpoint)
	{	mLogicalEndpoint=aLogicalEndpoint;
	}
	
	public void declareSpace(String aSpaceHash, String aPhysicalHash, String aDelegatedSpaceHash, IRepDeployedModules aModules)
	{
		
		String old=mSpaces.put(aSpaceHash,aDelegatedSpaceHash);
		if (old!=null && !old.equals(aDelegatedSpaceHash))
		{	mSpaces.put(aSpaceHash,old);
			//System.out.println("warning double mapping for "+mLogicalEndpoint);
			//System.out.println(aModules.componentForHash(aSpaceHash)+" -> "+aModules.componentForHash(aDelegatedSpaceHash));
			//System.out.println(aModules.componentForHash(aSpaceHash)+" -> "+aModules.componentForHash(old));
			return;
		}
		//mPhysicalForSpace.put(aSpaceHash, aPhysicalHash);
		
		if (aDelegatedSpaceHash!=null)
		{
			if (!mSpaces.containsKey(aDelegatedSpaceHash))
			{	mOrigin=aDelegatedSpaceHash;
			}
			mNotHeads.add(aDelegatedSpaceHash);
		}
		else if (mOrigin==null)
		{	mOrigin=aSpaceHash;
		}			
	}
	
	public String getOrigin()
	{	//return mOrigin;
		String result=mSpaces.keySet().iterator().next();
		for (String delegated : mSpaces.values())
		{	if (delegated!=null && !mSpaces.containsKey(delegated))
			{	result=delegated;
			}
		}
		return result;
	}
	
	public boolean startsIn(String aSpaceHash)
	{	return mSpaces.containsKey(aSpaceHash) && !mNotHeads.contains(aSpaceHash);
	}

	public String getPathStringFrom(String aSpaceHash)
	{
		StringBuilder sb=new StringBuilder();
		//sb.append(aSpaceHash);
		//sb.append("/");
		sb.append(getPathElement(aSpaceHash));
		String space=aSpaceHash;
		do
		{	String delegatedTo=mSpaces.get(space);
			if (delegatedTo!=null)
			{	sb.append(":");
				sb.append(getPathElement(delegatedTo));
				space=delegatedTo;
			}
			else
			{	break;
			}
		} while (true);
		
		return sb.toString();
	}
	
	public List<String> getPathFrom(String aSpaceHash)
	{
		List<String> result=new ArrayList<String>();
		String space=aSpaceHash;
		result.add(getPathElement(aSpaceHash));
		do
		{	String delegatedTo=mSpaces.get(space);
			if (delegatedTo!=null)
			{	String physical=getPathElement(delegatedTo);
				if (physical!=null)
				{	result.add(physical);
					space=delegatedTo;
				}
				else
				{	break;
				}
			}
			else
			{	break;
			}
		} while (true);
		return result;
	}
	
	private String getPathElement(String aHash)
	{
		return aHash;
		//return mPhysicalForSpace.get(aHash);
	}
	
}
