package org.netkernel.mod.architecture.bits.channel;

import java.util.*;

public class SpaceDefinition
{
	private String mHash;
	private int mDepth;
	private Set<SpaceDefinition> mDependencies;
	private Set<ChannelDefinition> mChannels;
	
	public SpaceDefinition(String aHash, int aDepth)
	{	mHash=aHash;
		mDepth=aDepth;
		mDependencies=new HashSet<SpaceDefinition>();
		mChannels=new HashSet<ChannelDefinition>();		
	}
	
	public String getSpaceHash()
	{	return mHash;
	}
	
	public int getDepth()
	{	
		return mDepth;
	}
	
	public void addDependency(SpaceDefinition aDependency)
	{	
		mDependencies.add(aDependency);
	}

	public void pushDepth(int aNewDepth)
	{	//System.out.println("push "+mHash);
		
		mDepth=aNewDepth;
		for (SpaceDefinition sd: mDependencies)
		{	if (sd.getDepth()>aNewDepth-1)
			{	sd.pushDepth(aNewDepth-1);
			}
		}
	}
	
	public void offsetDepth(int aOffset)
	{	mDepth+=aOffset;
	}
	
	public void addChannel(ChannelDefinition aChannel)
	{	mChannels.add(aChannel);
	}
	
	public Set<ChannelDefinition> getChannels()
	{	return mChannels;
	}
	
	public String toString()
	{	return mHash+" "+mDepth+" "+mDependencies.size();
	}
}
