<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl">
    <xsl:output method="html"/>
	<xsl:param name="param"><sortBy>idxRev</sortBy></xsl:param>
	<xsl:variable name="action">cache-resolution</xsl:variable>
	<xsl:variable name="imgbase">./pub/</xsl:variable>
	
    <xsl:template match="/cache">
		<div>
				<script type="text/javascript">
				<xsl:comment>
					function onClear()
					{	document.form.action2.value='clear';
						document.form.submit();
					}
				</xsl:comment>
				</script>
				
				<xrl:include>
				 <xrl:identifier>active:controlPanelInfoBox</xrl:identifier>
				 <xrl:argument name="content">
				   <div>
             <p>
               The Resolution Cache retains information about request resolutions for frequently executed requests.
             </p>
             <p>
               This tools allows you to examine the cache contents, hit rate and current size.
               The cache my be cleared by clicking the button labeled &quot;empty cache&quot;.
             </p>
				   </div>
				 </xrl:argument>
				</xrl:include> 				
				
				<table class="data-table">
					<tr class="vis-title">
						<td rowspan="2" style="background: white;">
							<form action="" method="post" name="form">
								<input type="hidden" name="action2" value=""/>
								<input type="submit" value="refresh" class="btn"/>
								<input type="button" value="empty cache" onclick="onClear()" class="btn"/>
							</form>
						</td>
						<td>Hit Rate</td>
						<td>Size</td>
					</tr>
					<tr>
						<td align="center"><xsl:value-of select="format-number(hits div (gets+1), '##%')"/></td>
						<td align="center"><xsl:value-of select="size"/></td>
					</tr>
				</table>
				
				<table class="data-table" width="100%">
					<tr class="vis-title">
						<td>Verb</td>
						<td>Resource Identifier</td>
						<td>Scope</td>
						<td>Endpoint</td>
						<td>LRU</td>
					</tr>
					
					<xsl:apply-templates select="item">
						<xsl:sort select="lru" order="ascending" data-type="number"/>
					</xsl:apply-templates>
				</table>
		</div>
	</xsl:template>
	
	
	<xsl:template match="item">
		<xsl:variable name="class">
			<xsl:choose>
				<xsl:when test="position() mod 2 = 0">
					<xsl:text>oddrow</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>evenrow</xsl:text>
				</xsl:otherwise>  
			</xsl:choose>
		</xsl:variable>
		<tr class="{$class}" >
			<td>
				<xsl:value-of select="verb"/>
			</td>
			<td>
				<xsl:call-template name="formatid">
					<xsl:with-param name="string" select="id"/>
				</xsl:call-template>
			</td>
			<td><xsl:value-of select="scope"/></td>
			<td>
				<xsl:call-template name="formatid">
					<xsl:with-param name="string" select="endpoint"/>
				</xsl:call-template>
			</td>
			<td><xsl:value-of select="lru"/></td>
		</tr>
	</xsl:template>
	
	<xsl:template name="formatid">
		<xsl:param name="string"/>
		<xsl:choose>
			<xsl:when test="string-length($string)&gt;50">
				<xsl:value-of select="substring($string, 0, 50)"/><wbr/><xsl:call-template name="formatid">
					<xsl:with-param name="string" select="substring($string, 50)"/>
				</xsl:call-template>
			 </xsl:when>
			 <xsl:otherwise>
			 	<xsl:value-of select="$string"/>
			 </xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
</xsl:stylesheet>
