<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>

	<xsl:param name="params"/>
		
	<xsl:template match="/">
	<div>
	
	<div class="panel panel-default">
<div class="btn-group">
  <button type="button" class="btn btn-info dropdown-toggle" data-toggle="dropdown" style="margin: 5px;">
    <span class="fnk fnk-pan"> </span> Cookbook <span class="caret"></span>
  </button>
  <ul class="dropdown-menu" role="menu">
  	<li role="presentation" class="dropdown-header">Simple</li>
    <li><a><xsl:attribute name="href">
							<![CDATA[?grammar=<grammar>%0D%0A%09<simple>res%3A%2F{country}%2F{state}%2F{city}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford&parse=Parse+Identifier&n1=country&v1=UK&n2=state&v2=Yorkshire&n3=city&v3=Bradford&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
						</xsl:attribute> REST path</a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<simple>res%3A%2F{country%3AUK}%2F{state%3A(Yorkshire|Cheshire)}%2F{city}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford&parse=Parse+Identifier&n1=country&v1=UK&n2=state&v2=Yorkshire&n3=city&v3=Bradford&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
    	</xsl:attribute>
		 REST path with Regex    	
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=%3Cgrammar%3E%0D%0A%09%3Csimple%3Eres%3A%2F{country}%2F{state}%2F{city}%3B{matrix}%3C%2Fsimple%3E%0D%0A%3C%2Fgrammar%3E&identifier=res%3A%2FUK%2FYorkshire%2FBradford%3Bscale%3D100%3Broads%3Dmain&parse=&n1=country&v1=UK&n2=state&v2=Yorkshire&n3=matrix&v3=Bradford%3Bscale%3D100%3Broads%3Dmain&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
    	</xsl:attribute>
    	 REST path unextracted Matrix URI
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<simple>res%3A%2F{country}%2F{state}%2F{city}%3Bscale%3D{scale}%3Broads%3D{roads}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford%3Bscale%3D100%3Broads%3Dmain&parse=Parse+Identifier&n1=country&v1=UK&n2=state&v2=Yorkshire&n3=city&v3=Bradford&n4=scale&v4=100&n5=roads&v5=main&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=&n12=&v12=&n13=&v13=]]>
    	</xsl:attribute>
    	 REST path extracted Matrix URI
    </a></li>
    <li class="divider"></li>
    <li role="presentation" class="dropdown-header">Active</li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<active>%0D%0A%09%09<identifier>active%3Abase<%2Fidentifier>%0D%0A%09%09<argument+name%3D"arg"+min%3D"0"+max%3D"1"%2F>%0D%0A%09<%2Factive>%0D%0A<%2Fgrammar>&identifier=active%3Abase%2Barg%40file%3A%2Fhome%2Fpjr%2Ftest.txt&parse=Parse+Identifier&n1=scheme&v1=active&n2=activeType&v2=base&n3=arg&v3=file%3A%2Fhome%2Fpjr%2Ftest.txt&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
    	</xsl:attribute>
    	 Basic
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<active>%0D%0A%09%09<identifier>active%3Abase<%2Fidentifier>%0D%0A%09%09<argument+name%3D"arg1"+min%3D"0"+max%3D"1"%2F>%0D%0A%09%09<argument+name%3D"arg2"+min%3D"0"+max%3D"1"%2F>%0D%0A%09<%2Factive>%0D%0A<%2Fgrammar>&identifier=active%3Abase%2Barg1%40file%3A%2Fhome%2Fpjr%2Ftest.txt%2Barg2%40http%3A%2F%2Fnetkernel.org&parse=Parse+Identifier&n1=scheme&v1=active&n2=activeType&v2=base&n3=arg1&v3=file%3A%2Fhome%2Fpjr%2Ftest.txt&n4=arg2&v4=http%3A%2F%2Fnetkernel.org&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=&n12=&v12=]]>
    	</xsl:attribute>
    	 Two Arguments
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<active>%0D%0A%09%09<identifier>active%3Aservice<%2Fidentifier>%0D%0A%09%09<argument+name%3D"operator"+min%3D"0"+max%3D"1"%2F>%0D%0A%09%09<argument+name%3D"operand"+min%3D"0"+max%3D"1"%2F>%0D%0A%09<%2Factive>%0D%0A<%2Fgrammar>&identifier=active%3Aservice%2Boperator%40res%3A%2Fmyscript%2Boperand%40res%3A%2Fmyresource&parse=Parse+Identifier&n1=scheme&v1=active&n2=activeType&v2=service&n3=operator&v3=res%3A%2Fmyscript&n4=operand&v4=res%3A%2Fmyresource&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=&n12=&v12=]]>
    	</xsl:attribute>
    	 Operator/Operand Convention
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<active>%0D%0A%09%09<identifier>active%3AserviceSomething<%2Fidentifier>%0D%0A%09%09<identifier>active%3AserviceSomethingElse<%2Fidentifier>%0D%0A%09%09<identifier>active%3AserviceAnother<%2Fidentifier>%0D%0A%09%09<identifier>active%3AserviceAndAnother<%2Fidentifier>%0D%0A%09%09<varargs%2F>%0D%0A%09<%2Factive>%0D%0A<%2Fgrammar>&identifier=active%3AserviceSomething%2Boperator%40res%3A%2Fmyscript%2Boperand%40res%3A%2Fmyresource&parse=Parse+Identifier&n1=scheme&v1=active&n2=activeType&v2=serviceSomething&n3=argName&v3=operator&n4=argValue&v4=res%3A%2Fmyscript&n5=argName&v5=operand&n6=argValue&v6=res%3A%2Fmyresource&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=&n12=&v12=&n13=&v13=&n14=&v14=]]>
    	</xsl:attribute>
    	 Multiple Logical Services and Varargs
    </a></li>
    <li class="divider"></li>
    <li role="presentation" class="dropdown-header">Standard</li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<group+name%3D"all">%0D%0A%09%09<optional>%2F<%2Foptional>%0D%0A%09%09<group+name%3D"path1">%0D%0A%09%09%09<regex+type%3D"alphanum"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A%09%2F%0D%0A%09%09<group+name%3D"path2">%0D%0A%09%09%09<regex+type%3D"alphanum"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A%09<%2Fgroup>%0D%0A<%2Fgrammar>&identifier=1%2F2&parse=Parse+Identifier&n1=all&v1=1%2F2&n2=path1&v2=1&n3=path2&v3=2&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
    	</xsl:attribute>
    	 Simple REST Path
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<group>%0D%0Aactive%3A%0D%0A%09%09<group+name%3D"type">%0D%0A%09%09%09<regex+type%3D"alphanum"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A%2Barg%40%0D%0A%09%09<group+name%3D"arg">%0D%0A%09%09%09<regex+type%3D"active-escaped-uri"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A%09<%2Fgroup>%0D%0A<%2Fgrammar>&identifier=active%3Abase%2Barg%40file%3A%2Fhome%2Fpjr%2Ftest.txt&parse=Parse+Identifier&n1=type&v1=base&n2=arg&v2=file%3A%2Fhome%2Fpjr%2Ftest.txt&n3=&v3=&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=]]>
    	</xsl:attribute>
    	 Basic Active URI
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<group>%0D%0Ares%3A%2F%0D%0A%09%09<group+name%3D"path">%0D%0A%09%09%09<regex>(must|be|one|of|these)<%2Fregex>%0D%0A%09%09<%2Fgroup>%0D%0A%09%2F%0D%0A%09%09<group+name%3D"number">%0D%0A%09%09%09<regex+type%3D"integer"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A%09%2F%0D%0A%09%09<group+name%3D"resource">%0D%0A%09%09%09<regex+type%3D"anything"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>&identifier=res%3A%2Fone%2F100%2Fanything!&parse=Parse+Identifier&n1=path&v1=one&n2=number&v2=100&n3=resource&v3=anything!&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
    	</xsl:attribute>
    	 REST Path with Integer field
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A<group>%0D%0Ares%3A%2F%0D%0A%09%09<group+name%3D"path">%0D%0A%09%09%09<regex>(must|be|one|of|these)<%2Fregex>%0D%0A%09%09<%2Fgroup>%0D%0A%09%2F%0D%0A%09%09<group+name%3D"number">%0D%0A%09%09%09<regex+type%3D"alphanum"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A%09%2F%0D%0A%09%09<group+name%3D"resource">%0D%0A%09%09%09<regex+type%3D"anything"%2F>%0D%0A%09%09<%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>&identifier=res%3A%2Fone%2Floose%2Fanything!&parse=Parse+Identifier&n1=path&v1=one&n2=number&v2=loose&n3=resource&v3=anything!&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=]]>
    	</xsl:attribute>
    	 REST Path with strict first and loose following paths
    </a></li>
    <li><a><xsl:attribute name="href">
    	<![CDATA[?grammar=<grammar>%0D%0A%09<group+name%3D"all">%0D%0A%09%09<group+max%3D"*"+min%3D"1">%0D%0A%09%09%09<optional>%2F<%2Foptional>%0D%0A%09%09%09<group+name%3D"path">%0D%0A%09%09%09%09<regex+type%3D"alphanum"%2F>%0D%0A%09%09%09<%2Fgroup>%0D%0A%09%09<%2Fgroup>%0D%0A%09<%2Fgroup>%0D%0A<%2Fgrammar>&identifier=1%2F2%2F3%2F4%2F5%2F6&parse=Parse+Identifier&n1=all&v1=1%2F2%2F3%2F4%2F5%2F6&n2=path&v2=1&n3=path&v3=2&n4=path&v4=3&n5=path&v5=4&n6=path&v6=5&n7=path&v7=6&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=&n12=&v12=&n13=&v13=&n14=&v14=&n15=&v15=]]>
    	</xsl:attribute>
    	 Repeated simple REST Path
    </a></li>
    
  </ul>
</div>
		<a class="btn btn-default" href="#quickref" style="margin: 2px;"><span class="fa fa-rocket"> </span> Grammar Quick Ref</a>
		<a class="btn btn-default" style="margin: 2px;" href="/book/view/book:guide:standardmodule/doc:logicalreference:module:standard:logical:grammar" ><span class="fa fa-book"> </span> Detailed Docs</a>
	</div>
			
				<form method="get" action="">
				
					<table cellpadding="4">
						<tr>
							<td valign="top">
								<table>
									<tr>
										<td class="label">Grammar:</td>
										<td>
											<textarea id="grammar" name="grammar" style="width:600px; height: 200px;">
												<xsl:if test="/results/errors">
													<xsl:attribute name="class">error</xsl:attribute>
												</xsl:if>
												<xsl:choose>
												<xsl:when test="$params and $params/hds/grammar">
													<xsl:value-of select="translate($params/hds/grammar, '&#xA;', '')"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:text>&lt;grammar&gt;...&lt;/grammar&gt;</xsl:text>
												</xsl:otherwise>
												</xsl:choose>
											</textarea>						
										</td>
									</tr>
									<xsl:if test="/results/errors">
										<tr>
											<td class="label">Errors:</td>
											<td>
												<table class="data-table">
													<tr class="vis-title">
														<td>Message</td><td>Location</td>
													</tr>
													<xsl:for-each select="results/errors/error">
														<tr>
															<td><xsl:value-of select="msg"/></td>
															<td><xsl:value-of select="loc"/></td>
														</tr>
													</xsl:for-each>
												</table>
											</td>
										</tr>
									</xsl:if>
									
									<tr>
										<td class="label">Identifier:</td>
										<td>
											<textarea name="identifier" style="width:600px; height:50px;">
												<xsl:choose>
													<xsl:when test="$params and $params/hds/identifier">
														<xsl:value-of select="$params/hds/identifier"/>
													</xsl:when>
													<xsl:otherwise>...</xsl:otherwise>
												</xsl:choose>
											</textarea>											
										</td>										
									</tr>
									<xsl:if test="results/constructed">
										<tr class="well">
											<td valign="top">Constructed:</td>
											<td style="font-size: 150%; font-weight:bold"><xsl:value-of select="results/constructed"/></td>
										</tr>
									</xsl:if>
									<xsl:if test="results/construct-error">
										<tr>
											<td valign="top">Errors:</td>
											<td class="error"><xsl:value-of select="results/construct-error"/></td>
										</tr>
									</xsl:if>
									<tr>
										<td/>
										<td valign="top">
											<button class="btn btn-primary" type="submit" name="parse"><span class="fa fa-arrow-down"> </span> Parse Identifier</button>
											<button style="margin-left: 20px;" class="btn btn-primary" type="submit" name="construct"><span class="fa fa-arrow-up"> </span> Construct Identifier</button>
										</td>
									</tr>
									<xsl:if test="results/matches">
										<tr class="well">
											<td class="label">Matches:</td>
											<td style="font-size: 150%; font-weight:bold">
												<xsl:choose>
													<xsl:when test="results/matches = 'true'">
														<span style="color:green;"><i class="fa fa-check"> </i> true</span>
													</xsl:when> 
													<xsl:otherwise>
														<span style="color:red;"><i class="fa fa-close"> </i> false</span>
													</xsl:otherwise>
												</xsl:choose>
											</td>
										</tr>
									</xsl:if>
									
									
									<tr>
										<td class="label">Parts:</td>
										<td>
											<table>
												<tr>
													<td><b>Name</b></td><td><b>Value</b></td>
												</tr>												
												<xsl:for-each select="results/parts/part">
													<tr>
														<td><input type="text" value="{name}" name="n{position()}"/></td>
														<td><input type="text" value="{value}" name="v{position()}"/></td>
													</tr>
												</xsl:for-each>
												
												<xsl:variable name="n" select="count(results/parts/part)"/>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+1"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+2"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+3"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+4"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+5"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+6"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+7"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+8"/></xsl:call-template>
												
											</table>
										</td>
									</tr>
								</table>
							</td>
							<td valign="top">
							</td>
						</tr>
					</table>
				</form>
				<xsl:call-template name="cookbook"/>
<script type="text/javascript"><xsl:comment>
<![CDATA[
$(document).ready(function(){
   	enableTextareaTab("grammar");
   }
);
]]>
</xsl:comment></script>
				
		</div>
	</xsl:template>
	
	<xsl:template name="part">
		<xsl:param name="p"/>
		<tr>
			<td><input type="text" value="" name="n{$p}"/></td>
			<td><input type="text" value="" name="v{$p}"/></td>
		</tr>
	</xsl:template>
	
	<xsl:template name="cookbook">
		<div style="height: 200em;" class="panel panel-default">
			
				
				
				<div class="well">
				<div id="quickref" class="panel panel-default">
					<div class="panel-heading">
						<div class="panel-title"><span class="fa fa-rocket"> </span> Grammar Quick Reference</div>
					</div>
				</div>
				<div class="panel panel-default">
					<div class="panel-heading">
						<div class="panel-title">Simple Grammar</div>
					</div>
				<div style="padding: 4px;">
				<table>
					<tr>
						<td>root:</td>
						<td>&lt;simple&gt;</td>
					</tr>
				</table>
				<p>
					Simple must start with &lt;simple&gt; and can have any number of <b>{argname}</b>
					argument delimiters mixed in with arbitrary static text. For example...										
				</p>
				<p>
					res:/{country}/{state}/{city}
				</p>
				<h4>Regex Patterns</h4>
				<p>
					Any argument delimiter may also implement an additional regex pattern after a colon (:) seperator
					between the argument name and the regex. For example...
				</p>
				<p>
					res:/{country:(UK|USA|France|Belgium)}/{state}/{city}
				</p>
				</div>
				</div>
				<div class="panel panel-default">
					<div class="panel-heading">
						<div class="panel-title">Active Grammar</div>
					</div>
					<div style="padding: 4px;">
				<table>
					<tr>
						<td>root:</td>
						<td>&lt;active&gt;</td>
					</tr>
					<tr>
						<td>identifier:</td>
						<td>&lt;identifier&gt;type&lt;/identifier&gt;</td>
					</tr>
					<tr>
						<td>argument:</td>
						<td>&lt;argument name="xxxx" min="x" max="x" /&gt;</td>
					</tr>
					<tr>
						<td>varargs:</td>
						<td>&lt;varargs/&gt;</td>
					</tr>
				</table>
				<p>
					active must start with &lt;active&gt; and can have any number of &lt;identifier&gt; elements
					each of which corresponds with a base for the active URI. Any number of arguments can be 
					specified and order is not significant. &lt;varargs/&gt; indicates any number of unnamed arguments
					may follow and will be parsed as active arguments.
				</p>
				</div>
				</div>
				
				<div class="panel panel-default">
					<div class="panel-heading">
						<div class="panel-title">Standard Grammar</div>
					</div>
				<div style="padding: 4px;">
				<p>
					The Standard Grammar is the most powerful and expressive grammar language.
				</p>
				<table>
					<tr>
						<td>group:</td>
						<td>&lt;group name="xxxx" min="x" max="x" encoding="x"&gt;
								<br/>
							all attributes are optional
							<ul>
								<li>name - identity of grammar part</li>
								<li>min - minimum number of times this must match (default = 1), * indicates unlimited</li>
								<li>max - maximum number of times this must match (default = 1), * indicates unlimited</li>
								<li>encoding - only currently supports: active, url-query, (default is to do no encoding)</li>
							</ul>
						</td>
					</tr>
					<tr>
						<td>regex:</td>
						<td>&lt;regex&gt;regex&lt;/regex&gt;</td>
					</tr>
					<tr>
						<td>interleave:</td>
						<td>&lt;interleave&gt; ... &lt;/interleave&gt; <br/> allows groups to be interleaved in any order</td>
					</tr>
					<tr>
						<td>choice:</td>
						<td>&lt;choice&gt; ... &lt;/choice&gt; <br/> choice of groups</td>
					</tr>
					<tr>
						<td>optional:</td>
						<td>&lt;optional&gt; ... &lt;/optional&gt; <br/> enclosed group is optional</td>
					</tr>
					<tr>
						<td>builtin types:</td>
						<td>&lt;regex type="xxxx" /&gt;
							<br/>
							Where <i>type</i> is optional and can be...
							<ul>
								<li>uri - matches a URI</li>
								<li>active-escaped-uri - strictly matches an Active URI argument</li>
								<li>active-escaped-uri-loose - matches an Active URI argument and is tolerant</li>
								<li>relative-path - matches a URI relative path</li>
								<li>relative-directory-path - matches a relative directory path</li>
								<li>path-segment - matches a single path segment</li>
								<li>integer - matches an integer</li>
								<li>float - matches an float</li>
								<li>nmtoken - BNF nmtoken</li>
								<li>alphanum - matches alphanumeric characters</li>
								<li>anything - matches anything</li>
								<li>nothing - matches nothing</li>
							</ul>
						</td>
					</tr>
				</table>
				<p>
					Standard Grammars must start with a &lt;group&gt; and can intersperse literal text with further groups and regex.
					A group with a name identifies a piece of the parsed identifier.  
				</p>
				</div>
			</div></div>
		</div>
	</xsl:template>
	
</xsl:stylesheet>
