<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl">
	<xsl:output method="xml" />

	<xsl:template match="/delete" >
		<div>
			<script type="text/javascript"><xsl:comment>
			var name="<xsl:value-of select="name"/>";
			<![CDATA[
				function onRemove() {
					if (confirm("Do you really want to remove "+name+"?"))
					{	$("#action").val("remove");
						$("#form").submit();
					}
				}
			]]></xsl:comment></script>
			<form id="form" method="post">
				<input type="hidden" id="action" name="action" value=""/>
				<xsl:choose>
					<xsl:when test="declarationType='STEM'">
						<xsl:call-template name="Stem"/>
					</xsl:when>
					<xsl:when test="declarationType='APPOSITE'">
						<xsl:call-template name="Apposite"/>
					</xsl:when>
					<xsl:when test="declarationType='MODULESD'">
						<xsl:call-template name="Modulesd"/>
					</xsl:when>
				</xsl:choose>
			</form>
		</div>
	</xsl:template>
	
	<xsl:template name="Stem">
		<div id="alert" class="alert alert-danger">
			<p><b>STEM modules cannot be removed.</b><br/>
			This module is critical to boot NetKernel and it cannot be removed.
			Updates and rollbacks of this module can be performed by Apposite.
			</p>
		</div>
		<div>
			<a class="btn btn-default" href="javascript:window.history.back()">cancel</a>
		</div>	
	</xsl:template>

	<xsl:template name="Apposite">
		<div id="alert" class="alert alert-danger">
			<p><b>APPOSITE modules should be managed by Apposite.</b><br/>
			This module <b><xsl:value-of select="name"/></b> has most likely been installed by Apposite and Apposite should
			be used to remove it.
			</p>
		</div>
		<div>
			<a class="btn btn-default" href="javascript:window.history.back()">cancel</a>
			<xsl:text> </xsl:text>
			<a class="btn btn-primary" href="/tools/apposite/">go to Apposite</a>
			<xsl:text> </xsl:text>
			<a class="btn btn-danger" href="javascript:onRemove()">force remove</a>
		</div>	
	</xsl:template>

	<xsl:template name="Modulesd">
		<div id="alert" class="alert alert-danger">
			<p><b>Module ready to be removed.</b><br/>
			Please click remove to remove module <b><xsl:value-of select="name"/></b>
			from NetKernel.
			</p>
		</div>
		<div>
			<a class="btn btn-default" href="javascript:window.history.back()">cancel</a>
			<xsl:text> </xsl:text>
			<a class="btn btn-danger" href="javascript:onRemove()">remove</a>
		</div>	
	</xsl:template>
			
</xsl:stylesheet> 
